﻿#include "RTU_Salve.h"

char read_buf[MAX_NUMBER];



/*********************************************************************************************
* 功能     ：   获取串口读取缓存区中数据的字节数
* 描述	   ：	向串口写入数据
* 返回值   ：   缓存区中数据的字节数
* m_hComm  ：   串口句柄
********************************************************************************************/
unsigned int GetBytesInCOM(HANDLE m_hComm)
{
	DWORD dwError = 0;  /** 错误码 */
	COMSTAT  comstat;   /** COMSTAT结构体,记录通信设备的状态信息 */
	memset(&comstat, 0, sizeof(COMSTAT));

	unsigned int BytesInQue = 0;
	/** 在调用ReadFile和WriteFile之前,通过本函数清除以前遗留的错误标志 */
	if (ClearCommError(m_hComm, &dwError, &comstat))
	{
		BytesInQue = comstat.cbInQue; /** 获取在输入缓冲区中的字节数 */
	}
	return BytesInQue;
}



int test(void)
{
	string COMM;
	cin >> COMM;
	HANDLE Handle_Com = Init_COM((LPCTSTR)COMM.c_str(), 9600, 8, 0, 1);
	if (Handle_Com == INVALID_HANDLE_VALUE)
	{
		cout << "初始化串口失败" << endl;
		getchar();
		return 0;
	}

	char write_buf[MAX_NUMBER];
	memset(write_buf, 0, MAX_NUMBER);
	DWORD dwRead;
	while (true)
	{
		//RTU主站，生成并发送请求，计时，读取响应报文,先发送后接收
		//生成请求报文
		//发送请求报文

		PurgeComm(Handle_Com, PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR | PURGE_TXABORT);//清除缓存
		while (1)
		{
			if (true == SendData(Handle_Com, "ok", 2))
			{
				cout << "发送请求报文成功" << endl;
				break;
			}
		}
		BOOL bReadOK = ReadFile(Handle_Com, read_buf, 256, &dwRead, NULL);
		if (bReadOK && (dwRead > 0))
		{
			read_buf[dwRead] = '\0';
			printf("收到响应：%s \r\n", read_buf);
		}
		else
			cout << "loss" << endl;
	}
	CloseHandle(Handle_Com);
	getchar();
	return 0;
}
